## vc 0.7.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,9 +19,19 @@
 vc_determine_compiler()
 
 if(ROOT_RELEASE)
-   file(READ "${CMAKE_INSTALL_PREFIX}/Module.mk" ROOT_MODULE_MK)
-   if(NOT ROOT_MODULE_MK MATCHES "\nMODNAME *:= *vc *\n")
-      message(FATAL_ERROR "CMAKE_INSTALL_PREFIX is incorrect. It must point to the Vc subdirectory inside ROOT/AliRoot")
+   if(EXISTS "${CMAKE_INSTALL_PREFIX}/Module.mk")
+      file(READ "${CMAKE_INSTALL_PREFIX}/Module.mk" ROOT_MODULE_MK)
+      if(NOT "${ROOT_MODULE_MK}" MATCHES "\nMODNAME *:= *vc *\n")
+         message(FATAL_ERROR "CMAKE_INSTALL_PREFIX is incorrect. It must point to the Vc subdirectory inside ROOT/AliRoot")
+      endif()
+      set(_extra_namespace "ROOT")
+   endif()
+   if(EXISTS "${CMAKE_INSTALL_PREFIX}/Vc.cmake")
+      file(READ "${CMAKE_INSTALL_PREFIX}/Vc.cmake" ALIROOT_VC_CMAKE)
+      if(NOT "${ALIROOT_VC_CMAKE}" MATCHES "\nmacro\\(ALICE_UseVc\\)\n")
+         message(FATAL_ERROR "CMAKE_INSTALL_PREFIX is incorrect. It must point to the Vc subdirectory inside ROOT/AliRoot")
+      endif()
+      set(_extra_namespace "AliRoot")
    endif()
 else()
    if(Vc_COMPILER_IS_GCC)
@@ -91,11 +101,14 @@
 
 vc_set_preferred_compiler_flags(WARNING_FLAGS BUILDTYPE_FLAGS)
 add_definitions("${Vc_DEFINITIONS}")
+if(Vc_COMPILER_IS_GCC AND Vc_GCC_VERSION VERSION_LESS 4.3.0)
+   add_definitions(-DVC_DONT_WARN_OLD_GCC) # this warning is only interesting for external users of Vc
+endif()
 
 if(Vc_COMPILER_IS_INTEL)
    # per default icc is not IEEE compliant, but we need that for verification
-   set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -w1 -fp-model precise")
-   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -w1 -fp-model precise")
+   set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -fp-model source")
+   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fp-model source")
 endif()
 
 if(CMAKE_BUILD_TYPE STREQUAL "" AND NOT CMAKE_CXX_FLAGS MATCHES "-O[123]")
@@ -104,17 +117,16 @@
 
 include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/include)
 
-add_custom_target(other VERBATIM)
-add_custom_target(Scalar COMMENT "build Scalar code" VERBATIM)
-add_custom_target(SSE COMMENT "build SSE code" VERBATIM)
-add_custom_target(AVX COMMENT "build AVX code" VERBATIM)
-
 if(NOT ROOT_RELEASE)
+   add_custom_target(other VERBATIM)
+   add_custom_target(Scalar COMMENT "build Scalar code" VERBATIM)
+   add_custom_target(SSE COMMENT "build SSE code" VERBATIM)
+   add_custom_target(AVX COMMENT "build AVX code" VERBATIM)
+
    set(libvc_compile_flags "-DVC_COMPILE_LIB")
    AddCompilerFlag("-fPIC" CXX_FLAGS libvc_compile_flags)
    vc_compile_for_all_implementations(_objs src/trigonometric.cpp FLAGS ${libvc_compile_flags}
-      ONLY SSE2 SSE3 SSSE3 SSE4_1 AVX SSE+XOP+FMA4 AVX+XOP+FMA4)
-   # add AVX+XOP+FMA AVX+FMA once there's a check in place whether the assembler can handle FMA instructions
+      ONLY SSE2 SSE3 SSSE3 SSE4_1 AVX SSE+XOP+FMA4 AVX+XOP+FMA4 AVX+XOP+FMA AVX+FMA)
    set(_srcs src/const.cpp src/cpuid.cpp src/support.cpp ${_objs})
    if(USE_AVX)
       list(APPEND _srcs src/avx_sorthelper.cpp)
@@ -139,9 +151,11 @@
    add_target_property(Vc LABELS "other")
    add_dependencies(other Vc)
 
-   install(TARGETS Vc DESTINATION lib/)
+   install(TARGETS Vc DESTINATION lib${LIB_SUFFIX})
+   install(DIRECTORY include/Vc/ DESTINATION include/Vc)
+   install(DIRECTORY scalar sse avx common DESTINATION include/Vc FILES_MATCHING REGEX "/*.(h|tcc|def)$")
 else()
-   # libVc should be compiled in the AliRoot tree, so we need to install the sources
+   # libVc should be compiled in the ROOT/AliRoot tree, so we need to install the sources
    #
    # Sadly there are messed up systems where putting include/Vc in the include paths will
    # break the standard library (e.g. MacOS X Lion with case insensitive filesystem).
@@ -152,16 +166,52 @@
       get_filename_component(_path "${CMAKE_BINARY_DIR}/${_src}" PATH)
       file(MAKE_DIRECTORY "${_path}")
       execute_process(
-         COMMAND sed "s,#include \\(.\\)\\(common\\|avx\\|sse\\|scalar\\)/,#include \\1Vc/\\2/,"
+         COMMAND sed -e "s,#include \\(.\\)\\(common\\|avx\\|sse\\|scalar\\)/,#include \\1Vc/\\2/,"
+                     -e "s,::Vc::,::${_extra_namespace}::Vc::,g"
+                     -e "s,/\\*OUTER_NAMESPACE_BEGIN\\*/,namespace ${_extra_namespace} {,"
+                     -e "s,/\\*OUTER_NAMESPACE_END\\*/,} // namespace ${_extra_namespace},"
+                     -e "s,/\\*NAMESPACE_ALIAS\\*/,namespace Vc = ${_extra_namespace}::Vc;,"
          INPUT_FILE ${CMAKE_SOURCE_DIR}/${_src}
          OUTPUT_FILE ${CMAKE_BINARY_DIR}/${_src}
          )
    endforeach()
    install(DIRECTORY ${CMAKE_BINARY_DIR}/src/ DESTINATION src)
-endif()
-
-install(DIRECTORY include/Vc/ DESTINATION include/Vc)
-install(DIRECTORY scalar sse avx common DESTINATION include/Vc FILES_MATCHING REGEX "/*.(h|tcc|def)$")
+
+   set(includes)
+   macro(copy_and_set_outer_namespace dst)
+      foreach(_name ${ARGN})
+         set(_dst "${dst}${_name}")
+         set(_src "${CMAKE_SOURCE_DIR}/${_name}")
+         get_filename_component(_dir "${_dst}" PATH)
+         add_custom_command(OUTPUT "${_dst}"
+            COMMAND mkdir -p "${_dir}"
+            COMMAND cp  "${_src}" "${_dst}"
+            COMMAND sed -e "s,::Vc::,::${_extra_namespace}::Vc::,g"
+                        -e "s,/\\*OUTER_NAMESPACE_BEGIN\\*/,namespace ${_extra_namespace} {,"
+                        -e "s,/\\*OUTER_NAMESPACE_END\\*/,} // namespace ${_extra_namespace},"
+                        -e "s,/\\*NAMESPACE_ALIAS\\*/,namespace Vc = ${_extra_namespace}::Vc;,"
+                        -i "${_dst}"
+            MAIN_DEPENDENCY "${_src}"
+            COMMENT "Rewrite ${_dst}"
+            WORKING_DIRECTORY "${CMAKE_BINARY_DIR}"
+            VERBATIM)
+         list(APPEND includes "${_dst}")
+      endforeach()
+   endmacro()
+
+   file(GLOB_RECURSE _srcs RELATIVE "${CMAKE_SOURCE_DIR}" include/*.h include/*.tcc include/*.def)
+   file(GLOB _src2 RELATIVE "${CMAKE_SOURCE_DIR}" include/Vc/*)
+   list(APPEND _srcs ${_src2})
+   list(REMOVE_DUPLICATES _srcs)
+   copy_and_set_outer_namespace("" "${_srcs}")
+
+   foreach(_dir in scalar sse avx common)
+      file(GLOB_RECURSE _srcs RELATIVE "${CMAKE_SOURCE_DIR}" ${_dir}/*.h ${_dir}/*.tcc ${_dir}/*.def)
+      copy_and_set_outer_namespace("include/Vc/" "${_srcs}")
+   endforeach()
+   add_custom_target(rewrite ALL DEPENDS ${includes})
+   install(DIRECTORY ${CMAKE_BINARY_DIR}/include/Vc/ DESTINATION include/Vc)
+endif()
 
 # read version parts from version.h to be put into VcConfig.cmake
 file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/include/Vc/version.h _version_lines REGEX "^#define VC_VERSION_STRING ")
