=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 include(AddFileDependencies)
 
-add_definitions(-DCOMPILE_FOR_UNIT_TESTS -DVC_CHECK_ALIGNMENT)
+add_definitions(-DCOMPILE_FOR_UNIT_TESTS) # -DVC_CHECK_ALIGNMENT)
 if(Vc_COMPILER_IS_MSVC)
    AddCompilerFlag("/wd4267") # Disable warning "conversion from 'size_t' to 'int', possible loss of data"
    AddCompilerFlag("/wd4723") # Disable warning "potential divide by 0" (suppress doesn't work)
@@ -67,6 +67,15 @@
       endif()
 
       if(USE_SSE2 AND NOT Vc_SSE_INTRINSICS_BROKEN)
+         set(DVC_IMPL "-DVC_IMPL=SSE")
+         if(USE_XOP)
+            set(DVC_IMPL "${DVC_IMPL}+XOP")
+         endif()
+         if(USE_FMA)
+            set(DVC_IMPL "${DVC_IMPL}+FMA")
+         elseif(USE_FMA4)
+            set(DVC_IMPL "${DVC_IMPL}+FMA4")
+         endif()
          set(_target "${name}_sse")
          list(FIND disabled_targets ${_target} _disabled)
          if(_disabled EQUAL -1)
@@ -74,7 +83,7 @@
             add_file_dependencies(${_name}.cpp "${_extra_deps}")
             add_executable(${_target} ${_name}.cpp)
             target_link_libraries(${_target} Vc)
-            add_target_property(${_target} COMPILE_FLAGS "-DVC_IMPL=SSE ${_extra_flags}")
+            add_target_property(${_target} COMPILE_FLAGS "${DVC_IMPL} ${_extra_flags}")
             add_target_property(${_target} LABELS "SSE")
             add_dependencies(SSE ${_target})
             add_test(${_target} "${CMAKE_CURRENT_BINARY_DIR}/${_target}")
@@ -88,7 +97,9 @@
          if(USE_XOP)
             set(DVC_IMPL "${DVC_IMPL}+XOP")
          endif()
-         if(USE_FMA4)
+         if(USE_FMA)
+            set(DVC_IMPL "${DVC_IMPL}+FMA")
+         elseif(USE_FMA4)
             set(DVC_IMPL "${DVC_IMPL}+FMA4")
          endif()
          set(_target "${name}_avx")
@@ -268,9 +279,3 @@
 target_link_libraries(linkTest Vc linkTestLibDynamic1 linkTestLibDynamic2 linkTestLibStatic)
 
 # Use the following program to generate the sincos-reference-*.dat files
-#add_executable(convert-sincos-reference convert-sincos-reference.cpp)
-
-set(_deps)
-foreach(fun sincos asin acos atan ln log2 log10)
-   foreach(filename reference-${fun}-sp.dat reference-${fun}-dp.dat)
-      add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${filename}"
