=== debian/changelog ===
vc (0.7.3-0ubuntu1) saucy; urgency=low

  * New upstream release (LP: #1223876) 

 -- Howard Chan <smartboyhw@gmail.com>  Wed, 11 Sep 2013 20:44:19 +0800

vc (0.7.2-0ubuntu1) saucy; urgency=low

  * New upstream release

 -- Jonathan Riddell <jriddell@ubuntu.com>  Fri, 07 Jun 2013 16:39:44 +0100
